import 'package:flutter/material.dart';
import 'package:rothko_mobile/rothko.dart';
import 'package:rothko_mobile/rothko_system/utilities/colors.dart';

class ChipsDefaultColored extends StatelessWidget {
  final Color? chipColor;
  final String text;

  TextStyle textStyle;

  ChipsDefaultColored({
    this.textStyle = const TextStyle(),
    required this.chipColor,
    required this.text,
  });
  @override
  Widget build(BuildContext context) {
    return Chip(
      padding: EdgeInsets.symmetric(vertical: 8, horizontal: 15),
      label: Text(
        text,
        style: textStyle.copyWith(
            color: chipColor == kErrorLighten5
                ? kErrorBase
                : chipColor == kSuccessLighten5
                    ? kSuccessBase
                    : chipColor == kAccentLighten5
                        ? kAccentBase
                        : chipColor == kWarningLighten5
                            ? kWarningBase
                            : chipColor == kPrimaryBase
                                ? kLightNeutralLighten0
                                : chipColor == kSuccessBase
                                    ? kLightNeutralLighten0
                                    : chipColor == kWarningBase
                                        ? kLightNeutralLighten0
                                        : chipColor == kAccentBase
                                            ? kLightNeutralLighten0
                                            : chipColor == kErrorBase
                                                ? kLightNeutralLighten0
                                                : kPrimaryBase,
            fontFamily: 'Proxima Nova',
            fontWeight: FontWeight.w600),
      ),
      backgroundColor: chipColor ??
          (RothkoCache.getTheme!(context) == ThemeMode.light
              ? kDarkNeutralBase
              : kLightNeutralLighten5),
    );
  }
}
