import 'package:flutter/material.dart';
import 'package:rothko_mobile/cache.dart';
import 'package:rothko_mobile/rothko_system/utilities/colors.dart';

class ChipsDefault extends StatelessWidget {
  Color? textColor;
  Color? chipColor;
  final String text;
  final double width;
  TextStyle textStyle;

  ChipsDefault(
      {required this.text,
      this.textColor,
      this.width = 0,
      this.chipColor,
      this.textStyle = const TextStyle()}) {
    if (this.textColor != null) {
      this.textStyle = this.textStyle.copyWith(color: this.textColor);
    }
  }
  @override
  Widget build(BuildContext context) {
    return Chip(
      padding: EdgeInsets.symmetric(vertical: 8, horizontal: 15),
      label: Text(
        text,
        style: textStyle.copyWith(
            color: Theme.of(context).canvasColor,
            fontFamily: 'Proxima Nova',
            fontWeight: FontWeight.w600),
      ),
      backgroundColor: chipColor ??
          (RothkoCache.getTheme!(context) == ThemeMode.light
              ? kDarkNeutralBase
              : kLightNeutralLighten5),
    );
  }
}
