import 'package:flutter/material.dart';
import 'package:rothko_mobile/cache.dart';
import 'package:rothko_mobile/rothko_system/utilities/colors.dart';

class ChipsRemovable extends StatelessWidget {
  final Color? chipColor;
  Function onDeleted;
  final String text;
  final double? fontSize;

  ChipsRemovable(
      {this.fontSize,
      required this.text,
      this.chipColor,
      required this.onDeleted});

  @override
  Widget build(BuildContext context) {
    return Chip(
      onDeleted: () => onDeleted,
      padding: EdgeInsets.symmetric(horizontal: 15),
      label: Text(
        text,
        style: TextStyle(
            color: Theme.of(context).canvasColor,
            fontFamily: 'Proxima Nova',
            fontWeight: FontWeight.w600),
      ),
      backgroundColor: chipColor ??
          (RothkoCache.getTheme!(context) == ThemeMode.light
              ? kDarkNeutralBase
              : kLightNeutralLighten5),
      deleteIcon: Icon(
        Icons.cancel_rounded,
      ),
      deleteIconColor: RothkoCache.getTheme!(context) == ThemeMode.light
          ? kLightNeutralLighten5
          : kDarkNeutralBase,
    );
  }
}
