import 'package:flutter/material.dart';
import 'package:rothko_mobile/rothko_system/utilities/colors.dart';

class Paper extends StatelessWidget {
  final double? spreadRadius, borderRadius, blurRadius;
  final Color? color, shadowColor;
  final bool? hasElevation;
  final Widget? child;

  Paper(
      {this.spreadRadius,
      this.color,
      this.borderRadius,
      this.shadowColor,
      this.blurRadius,
      this.hasElevation,
      this.child});
  @override
  Widget build(BuildContext context) {
    return Material(
      shadowColor: shadowColor,
      elevation: hasElevation! ? 10.0 : 0.0,
      borderRadius: BorderRadius.circular(borderRadius!),
      child: Container(
        height: MediaQuery.of(context).size.height * 0.9,
        width: MediaQuery.of(context).size.width * 0.9,
        decoration: BoxDecoration(
            border: Border.all(
                color:
                    hasElevation! ? Colors.transparent : kLightNeutralLighten1),
            color: color,
            borderRadius: BorderRadius.circular(borderRadius!),
            boxShadow: [
              BoxShadow(
                color: shadowColor!,
                offset: Offset(0, 50),
                blurRadius: blurRadius!,
                spreadRadius: -(spreadRadius!),
              )
            ]),
        child: child,
      ),
    );
  }
}
