import 'package:flutter/material.dart';

class PrimaryGradient extends StatelessWidget {
  final double? width, height, radius;

  PrimaryGradient({
    @required this.height,
    @required this.width,
    @required this.radius,
  });

  @override
  Widget build(BuildContext context) {
    return Container(
      width: width,
      height: height,
      decoration: BoxDecoration(
          shape: BoxShape.rectangle,
          gradient: RadialGradient(
              radius: radius!,
              center: Alignment(0.486, 0.0),
              colors: [Color(0xFF0047CC), Color(0xFF031F54)],
              stops: [0.0, 1.0])),
    );
  }
}

class WarningGradient extends StatelessWidget {
  final double? width, height, radius;

  WarningGradient({
    @required this.height,
    @required this.width,
    @required this.radius,
  });

  @override
  Widget build(BuildContext context) {
    return Container(
      width: width,
      height: height,
      decoration: BoxDecoration(
          shape: BoxShape.rectangle,
          gradient: RadialGradient(
              radius: radius!,
              center: Alignment(0.486, 0.0),
              colors: [Color(0xFFDE6C3B), Color(0xFF842B04)],
              stops: [0.0, 1.0])),
    );
  }
}

class SuccessGradient extends StatelessWidget {
  final double? width, height, radius;

  SuccessGradient({
    @required this.height,
    @required this.width,
    @required this.radius,
  });

  @override
  Widget build(BuildContext context) {
    return Container(
      width: width,
      height: height,
      decoration: BoxDecoration(
          shape: BoxShape.rectangle,
          gradient: RadialGradient(
              radius: radius!,
              center: Alignment(0.486, 0.0),
              colors: [Color(0xFF4ECC4E), Color(0xFF157D15)],
              stops: [0.0, 1.0])),
    );
  }
}

class AccentGradient extends StatelessWidget {
  final double? width, height, radius;

  AccentGradient({
    @required this.height,
    @required this.width,
    @required this.radius,
  });

  @override
  Widget build(BuildContext context) {
    return Container(
      width: width,
      height: height,
      decoration: BoxDecoration(
          shape: BoxShape.rectangle,
          gradient: RadialGradient(
              radius: radius!,
              center: Alignment(0.486, 0.0),
              colors: [Color(0xFF7664EB), Color(0xFF0B0438)],
              stops: [0.0, 1.0])),
    );
  }
}

class ErrorGradient extends StatelessWidget {
  final double? width, height, radius;

  ErrorGradient({
    @required this.height,
    @required this.width,
    @required this.radius,
  });

  @override
  Widget build(BuildContext context) {
    return Container(
      width: width,
      height: height,
      decoration: BoxDecoration(
          shape: BoxShape.rectangle,
          gradient: RadialGradient(
              radius: radius!,
              center: Alignment(0.486, 0.0),
              colors: [Color(0xFFEE0020), Color(0xFF760615)],
              stops: [0.0, 1.0])),
    );
  }
}
