import 'package:flutter/material.dart';
import 'package:rothko_mobile/knobs/select_knobs.dart';
import 'package:rothko_mobile/rothko.dart';
import 'package:rothko_mobile/rothko_system/avatar/circe-personas.dart';
import 'package:rothko_mobile/rothko_system/avatar/default-filled-avatar.dart';
import 'package:rothko_mobile/rothko_system/avatar/default-outline-avatar.dart';
import 'package:rothko_mobile/rothko_system/avatar/square-filled-avatar.dart';
import 'package:rothko_mobile/rothko_system/avatar/square-outline-avatar.dart';
import 'package:rothko_mobile/rothko_system/badges/badges_positioned.dart';
import 'package:rothko_mobile/rothko_system/badges/bento_badges.dart';
import 'package:rothko_mobile/rothko_system/banners/banner_filled_button.dart';
import 'package:rothko_mobile/rothko_system/banners/banner_icon.dart';
import 'package:rothko_mobile/rothko_system/banners/banner_outline_button.dart';
import 'package:rothko_mobile/rothko_system/buttons/button.dart';
import 'package:rothko_mobile/rothko_system/charts/circular-indicator.dart';
import 'package:rothko_mobile/rothko_system/charts/linear_progress_indicator.dart';
import 'package:rothko_mobile/rothko_system/charts/rotate-indicator.dart';
import 'package:rothko_mobile/rothko_system/checkbox/checkbox.dart';
import 'package:rothko_mobile/rothko_system/chips/default/default-colored.dart';
import 'package:rothko_mobile/rothko_system/chips/default/default.dart';
import 'package:rothko_mobile/rothko_system/chips/icon-avatar/chips-avatar.dart';
import 'package:rothko_mobile/rothko_system/chips/removable/removable-colored.dart';
import 'package:rothko_mobile/rothko_system/chips/removable/removable.dart';
import 'package:rothko_mobile/rothko_system/dialog/default_dialog.dart';
import 'package:rothko_mobile/rothko_system/dialog/dialog_scrollable.dart';
import 'package:rothko_mobile/rothko_system/dialog/form_dialog.dart';
import 'package:rothko_mobile/rothko_system/logo/bento_logo.dart';
import 'package:rothko_mobile/rothko_system/logo/bento_logomark.dart';
import 'package:rothko_mobile/rothko_system/logo/bento_wordmark.dart';
import 'package:rothko_mobile/rothko_system/logo/people_logo.dart';
import 'package:rothko_mobile/rothko_system/logo/people_logomark.dart';
import 'package:rothko_mobile/rothko_system/pickers/datePicker.dart';
import 'package:rothko_mobile/rothko_system/pickers/new_datePicker.dart';
import 'package:rothko_mobile/rothko_system/radio/radio.dart';
import 'package:rothko_mobile/rothko_system/searchbox/search.dart';
import 'package:rothko_mobile/rothko_system/select/default.dart';
import 'package:rothko_mobile/rothko_system/select/dense-default.dart';
import 'package:rothko_mobile/rothko_system/select/hint-default.dart';
import 'package:rothko_mobile/rothko_system/select/icons-default.dart';
import 'package:rothko_mobile/rothko_system/sheets/paper.dart';
import 'package:rothko_mobile/rothko_system/sliders/slider_paddle.dart';
import 'package:rothko_mobile/rothko_system/sliders/slider_simple.dart';
import 'package:rothko_mobile/rothko_system/snackbar/snackbar.dart';
import 'package:rothko_mobile/rothko_system/snackbar/snackbar_helper.dart';
import 'package:rothko_mobile/rothko_system/switches/switches.dart';
import 'package:rothko_mobile/rothko_system/tabs/tabs.dart';
import 'package:rothko_mobile/rothko_system/tabs/tabs_dynamic.dart';
import 'package:rothko_mobile/rothko_system/textarea/clearable.dart';
import 'package:rothko_mobile/rothko_system/textarea/default.dart';
import 'package:rothko_mobile/rothko_system/textfields/clearable.dart';
import 'package:rothko_mobile/rothko_system/textfields/default.dart';
import 'package:rothko_mobile/rothko_system/textfields/dense-default.dart';
import 'package:rothko_mobile/rothko_system/textfields/password.dart';
import 'package:rothko_mobile/rothko_system/textfields/withSuffixText.dart';
import 'package:rothko_mobile/rothko_system/tooltip/default.dart';
import 'package:rothko_mobile/rothko_system/utilities/color-gradients.dart';
import 'package:rothko_mobile/rothko_system/utilities/colors.dart';
import 'package:rothko_mobile/widgets/story.dart';
import 'package:rothko_mobile/widgets/storybook.dart';

class StoryApp extends StatelessWidget {
  final GlobalKey<ScaffoldState> _scaffoldKey = new GlobalKey<ScaffoldState>();
  @override
  Widget build(BuildContext context) => Scaffold(
      key: _scaffoldKey,
      body: Storybook(
        children: [
          ///create classes for each widgets in appropriate named folders under ./rothko_system
          ///logo starts here
          Story(
            section: 'Logo',
            name: 'Bento Logo Normal',
            padding: EdgeInsets.all(5), // optional padding customization

            builder: (_, k) => BentoLogoNormal(
              urlType: k.options('Logo Variation',
                  initial: "assets/img/bento_logonormal.png",
                  options: [
                    Option('Variation 1', "assets/img/bento_logonormal.png"),
                    Option('Variation 2', "assets/img/bento_logonormal2.png")
                  ]),
            ),
          ),
          Story(
            section: 'Logo',
            name: 'Bento Logomark',
            padding: EdgeInsets.all(5), // optional padding customization

            builder: (_, k) => BentoLogomark(
              urlType: k.options('Logomark Variation',
                  initial: "assets/img/bento_logomark.png",
                  options: [
                    Option('Variation 1', "assets/img/bento_logomark.png"),
                    Option('Variation 2', "assets/img/bento_logomark2.png")
                  ]),
            ),
          ),
          Story.simple(
            section: 'Logo',
            name: 'Bento Wordmark',
            padding: EdgeInsets.all(5), // optional padding customization
            child: BentoWordmark(),
          ),
          //bento Logo ends

          //people logo starts
          Story(
            section: 'Logo',
            name: 'People Logo Normal',
            padding: EdgeInsets.all(5), // optional padding customization

            builder: (_, k) => PeopleLogoNormal(
              urlType: k.options('Logo Variation',
                  initial: "assets/img/people_logonormal.png",
                  options: [
                    Option('Variation 1', "assets/img/people_logonormal.png"),
                    Option('Variation 2', "assets/img/people_logonormal2.png")
                  ]),
            ),
          ),
          Story(
            section: 'Logo',
            name: 'People Logomark',
            padding: EdgeInsets.all(5), // optional padding customization

            builder: (_, k) => PeopleLogomark(
              urlType: k.options('Logomark Variation',
                  initial: "assets/img/people_logomark.png",
                  options: [
                    Option('Variation 1', "assets/img/people_logomark.png"),
                    Option('Variation 2', "assets/img/people_logomark2.png")
                  ]),
            ),
          ),

          //people logo ends

          ///logo ends here

          ///AVATAR STARTS HERE

          Story(
            section: 'Avatar',
            name: 'Default Outline',
            padding: EdgeInsets.all(5), // optional padding customization
            builder: (_, k) => DefaultOutlineAvatar(
              outlineColor: k.options(
                "Color",
                initial: kSuccessBase,
                options: [
                  Option('Purple', kAccentBase),
                  Option('Green', kSuccessBase),
                  Option('Orange', kWarningBase),
                  Option('Red', kErrorBase),
                ],
              ),
            ),
          ),

          Story(
            section: 'Avatar',
            name: 'Default Filled',
            padding: EdgeInsets.all(5), // optional padding customization
            builder: (_, k) => DefaultFillAvatar(
                // backgroundImage:
                //     AssetImage('assets/img/personas/circle-user2.png'),
                ),
          ),

          Story(
            section: 'Avatar',
            name: 'Circle Persona',
            padding: EdgeInsets.all(5), // optional padding customization
            builder: (_, k) => CirclePersonaAvatar(
              urlType: k.options('Personas',
                  initial: "assets/img/personas/circle-user.png",
                  options: [
                    Option(
                        'Variation 1', "assets/img/personas/circle-user.png"),
                    Option(
                        'Variation 2', "assets/img/personas/circle-user2.png"),
                    Option(
                        'Variation 3', "assets/img/personas/circle-user3.png"),
                    Option(
                        'Variation 4', "assets/img/personas/circle-user4.png"),
                    Option(
                        'Variation 5', "assets/img/personas/circle-user5.png"),
                  ]),
            ),
          ),

          Story(
            section: 'Avatar',
            name: 'Square Outline',
            padding: EdgeInsets.all(5), // optional padding customization
            builder: (_, k) => SquareAvatarOutline(
              size: 48.0,
              avatarColor:
                  k.options('Avatar Color', initial: kSuccessBase, options: [
                Option('Green', kSuccessBase),
                Option('Red', kErrorBase),
                Option('Orange', kWarningBase),
                Option('Purple', kAccentBase),
              ]),

              /// if passed image of avatar is plugged either network or asset
              // profileDecorImgType:
              //     AssetImage('assets/img/personas/circle-user2.png'),
              username: k.text('Username', initial: 'Bento Mobile'),
              profileImageUrl: k.options('Personas',
                  initial: "assets/img/personas/circle-user3.png",
                  options: [
                    Option('No Image', ""),
                    Option(
                        'Variation 2', "assets/img/personas/circle-user2.png"),
                    Option(
                        'Variation 3', "assets/img/personas/circle-user3.png"),
                    Option(
                        'Variation 4', "assets/img/personas/circle-user4.png"),
                    Option(
                        'Variation 5', "assets/img/personas/circle-user5.png"),
                  ]),
            ),
          ),

          Story(
            section: 'Avatar',
            name: 'Square Filled',
            padding: EdgeInsets.all(5), // optional padding customization
            builder: (_, k) => SquareAvatarFilled(
              size: 48.0,
              avatarColor:
                  k.options('Avatar Color', initial: kSuccessBase, options: [
                Option('Green', kSuccessBase),
                Option('Red', kErrorBase),
                Option('Orange', kWarningBase),
                Option('Purple', kAccentBase),
              ]),
              username: k.text('Username', initial: 'Bento Mobile'),

              /// if passed image of avatar is plugged either network or asset
              // profileDecorImgType:
              //     AssetImage('assets/img/personas/circle-user2.png'),
              profileImageUrl: k.options('Personas',
                  initial: "assets/img/personas/circle-user2.png",
                  options: [
                    Option('No Image', ""),
                    Option(
                        'Variation 2', "assets/img/personas/circle-user2.png"),
                    Option(
                        'Variation 3', "assets/img/personas/circle-user3.png"),
                    Option(
                        'Variation 4', "assets/img/personas/circle-user4.png"),
                    Option(
                        'Variation 5', "assets/img/personas/circle-user5.png"),
                  ]),
            ),
          ),

          ///AVATAR ENDS

          ///badges begin

          Story(
              section: 'Badges',
              name: 'Primary Badge',
              // padding: EdgeInsets.all(5), // optional padding customization
              builder: (_, k) => Badges(
                    text: k.text('Text', initial: '12'),
                    primary: true,
                    textColor: k.options(
                      'Text Color',
                      initial: kPrimaryLighten0,
                      options: [
                        Option('Normal', kPrimaryLighten0),
                        Option('Lighten5', kPrimaryBase)
                      ],
                    ),
                    bgColor: k.options(
                      'Background Color',
                      initial: kPrimaryBase,
                      options: [
                        Option('Normal', kPrimaryBase),
                        Option('Lighten5', kPrimaryLighten5)
                      ],
                    ),
                  )),

          Story(
              section: 'Badges',
              name: 'Success Badge',
              // padding: EdgeInsets.all(5), // optional padding customization
              builder: (_, k) => Badges(
                    text: k.text('Text', initial: '12'),
                    textColor: k.options(
                      'Text Color',
                      initial: kPrimaryLighten0,
                      options: [
                        Option('Normal', kPrimaryLighten0),
                        Option('Lighten5', kSuccessBase)
                      ],
                    ),
                    bgColor: k.options(
                      'Background Color',
                      initial: kSuccessBase,
                      options: [
                        Option('Normal', kSuccessBase),
                        Option('Lighten5', kSuccessLighten5)
                      ],
                    ),
                  )),

          Story(
              section: 'Badges',
              name: 'Accent Badge',
              // padding: EdgeInsets.all(5), // optional padding customization
              builder: (_, k) => Badges(
                    text: k.text('Text', initial: '12'),
                    textColor: k.options(
                      'Text Color',
                      initial: kPrimaryLighten0,
                      options: [
                        Option('Normal', kPrimaryLighten0),
                        Option('Lighten5', kAccentBase)
                      ],
                    ),
                    bgColor: k.options(
                      'Background Color',
                      initial: kAccentBase,
                      options: [
                        Option('Normal', kAccentBase),
                        Option('Lighten5', kAccentLighten5)
                      ],
                    ),
                  )),

          Story(
              section: 'Badges',
              name: 'Warning Badge',
              // padding: EdgeInsets.all(5), // optional padding customization
              builder: (_, k) => Badges(
                    text: k.text('Text', initial: '12'),
                    textColor: k.options(
                      'Text Color',
                      initial: kPrimaryLighten0,
                      options: [
                        Option('Normal', kPrimaryLighten0),
                        Option('Lighten5', kWarningBase)
                      ],
                    ),
                    bgColor: k.options(
                      'Background Color',
                      initial: kWarningBase,
                      options: [
                        Option('Normal', kWarningBase),
                        Option('Lighten5', kWarningLighten5)
                      ],
                    ),
                  )),

          Story(
              section: 'Badges',
              name: 'Error Badge',
              // padding: EdgeInsets.all(5), // optional padding customization
              builder: (_, k) => Badges(
                    text: k.text('Text', initial: '12'),
                    textColor: k.options(
                      'Text Color',
                      initial: kPrimaryLighten0,
                      options: [
                        Option('Normal', kPrimaryLighten0),
                        Option('Lighten5', kErrorBase)
                      ],
                    ),
                    bgColor: k.options(
                      'Background Color',
                      initial: kErrorBase,
                      options: [
                        Option('Normal', kErrorBase),
                        Option('Lighten5', kErrorLighten5)
                      ],
                    ),
                  )),

          Story(
              section: 'Badges',
              name: 'Positioned Badges',
              // padding: EdgeInsets.all(5), // optional padding customization
              builder: (_, k) => BadgesPostioned(
                  text: k.text('Text', initial: '12'),
                  overlapping:
                      k.options("Overlapping", initial: false, options: [
                    Option('True', true),
                    Option('False', false),
                  ]),
                  type: k.options("Type", initial: 'badge', options: [
                    Option('Badge', 'badge'),
                    Option('Dot', 'dot'),
                  ]),
                  alignment: k.options(
                    'Alignment',
                    initial: Alignment.bottomRight,
                    options: [
                      Option('Bottom Right', Alignment.bottomRight),
                      Option('Bottom Left', Alignment.bottomLeft),
                      Option('Top Left', Alignment.topLeft),
                      Option('Top Right', Alignment.topRight),
                    ],
                  ),
                  textColor: kPrimaryBase,
                  bgColor: kPrimaryLighten5)),

          ///badges end

          ///Gradients starts here
          Story(
            section: 'Gradients',
            name: 'Primary Gradients',
            padding: EdgeInsets.all(5), // optional padding customization
            builder: (_, k) => PrimaryGradient(
              height: k.slider('height', initial: 50.0, max: 200.0, min: 50.0),
              width: k.slider('width', initial: 100.0, max: 200.0, min: 50.0),
              radius: k.slider('radius', initial: 0.5, max: 1.0, min: 0.1),
            ),
          ),

          Story(
            section: 'Gradients',
            name: ' Warning Gradients',
            padding: EdgeInsets.all(5), // optional padding customization
            builder: (_, k) => WarningGradient(
              height: k.slider('height', initial: 50.0, max: 200.0, min: 50.0),
              width: k.slider('width', initial: 100.0, max: 200.0, min: 50.0),
              radius: k.slider('radius', initial: 0.5, max: 1.0, min: 0.1),
            ),
          ),

          Story(
            section: 'Gradients',
            name: ' Accent Gradients',
            padding: EdgeInsets.all(5), // optional padding customization
            builder: (_, k) => AccentGradient(
              height: k.slider('height', initial: 50.0, max: 200.0, min: 50.0),
              width: k.slider('width', initial: 100.0, max: 200.0, min: 50.0),
              radius: k.slider('radius', initial: 0.8, max: 1.0, min: 0.1),
            ),
          ),
          Story(
            section: 'Gradients',
            name: ' Error Gradients',
            padding: EdgeInsets.all(5), // optional padding customization
            builder: (_, k) => ErrorGradient(
              height: k.slider('height', initial: 50.0, max: 200.0, min: 50.0),
              width: k.slider('width', initial: 100.0, max: 200.0, min: 50.0),
              radius: k.slider('radius', initial: 0.5, max: 1.0, min: 0.1),
            ),
          ),
          Story(
            section: 'Gradients',
            name: ' Success Gradients',
            padding: EdgeInsets.all(5), // optional padding customization
            builder: (_, k) => SuccessGradient(
              height: k.slider('height', initial: 50.0, max: 200.0, min: 50.0),
              width: k.slider('width', initial: 100.0, max: 200.0, min: 50.0),
              radius: k.slider('radius', initial: 0.5, max: 1.0, min: 0.1),
            ),
          ),

          /// GRADIENT ENDS HERE
          /// SEARCH BEGIN HERE

          Story.simple(
            section: 'Search',
            name: 'Default',
            padding: EdgeInsets.all(5), // optional padding customization
            child: SearchBox(
              label: 'Label',
              enabled: true,
              hint: "Search",
              readOnly: false,
            ),
          ),

          /// SEARCH END HERE

          ///CHIPS BEGIN HERE
          Story(
            section: 'Chips',
            name: 'Default- Chips',
            padding: EdgeInsets.all(5), // optional padding customization
            builder: (_, k) =>
                ChipsDefault(text: k.text('title', initial: 'Default')),
          ),

          Story(
            section: 'Chips',
            name: 'Default - Colored',
            padding: EdgeInsets.all(5), // optional padding customization
            builder: (_, k) => ChipsDefaultColored(
              chipColor: k.options(
                'Chip Color',
                initial: kPrimaryLighten5,
                options: [
                  Option('Primary Light', kPrimaryLighten5),
                  Option('Success Light', kSuccessLighten5),
                  Option('Accent Light', kAccentLighten5),
                  Option('Warning Light', kWarningLighten5),
                  Option('Error Light', kErrorLighten5),
                  Option('Primary Base', kPrimaryBase),
                  Option('Success Base', kSuccessBase),
                  Option('Accent Base', kAccentBase),
                  Option('Warning Base', kWarningBase),
                  Option('Error Base', kErrorBase),
                ],
              ),
              text: k.text('Chip title', initial: 'Default'),
            ),
          ),

          Story(
            section: 'Chips',
            name: 'Removable',
            padding: EdgeInsets.all(5), // optional padding customization
            builder: (_, k) => ChipsRemovable(
              onDeleted: () {},
              text: k.text('title', initial: 'Remove'),
            ),
          ),

          Story(
            section: 'Chips',
            name: 'Removable-Colored',
            padding: EdgeInsets.all(5), // optional padding customization
            builder: (_, k) => ChipsRemovableColored(
              onDeleted: () {},
              chipColor: k.options(
                'Chip Color',
                initial: kPrimaryLighten5,
                options: [
                  Option('Primary Light', kPrimaryLighten5),
                  Option('Success Light', kSuccessLighten5),
                  Option('Accent Light', kAccentLighten5),
                  Option('Warning Light', kWarningLighten5),
                  Option('Error Light', kErrorLighten5),
                  Option('Primary Base', kPrimaryBase),
                  Option('Success Base', kSuccessBase),
                  Option('Accent Base', kAccentBase),
                  Option('Warning Base', kWarningBase),
                  Option('Error Base', kErrorBase),
                ],
              ),
              text: k.text('title', initial: 'Remove'),
            ),
          ),
          Story(
            section: 'Chips',
            name: 'Avatar-Colored',
            padding: EdgeInsets.all(5), // optional padding customization
            builder: (_, k) => ChipsAvatar(
              chipColor: k.options(
                'Chip Color',
                initial: kPrimaryLighten5,
                options: [
                  Option('Primary Light', kPrimaryLighten5),
                  Option('Success Light', kSuccessLighten5),
                  Option('Accent Light', kAccentLighten5),
                  Option('Warning Light', kWarningLighten5),
                  Option('Error Light', kErrorLighten5),
                  Option('Primary Base', kPrimaryBase),
                  Option('Success Base', kSuccessBase),
                  Option('Accent Base', kAccentBase),
                  Option('Warning Base', kWarningBase),
                  Option('Error Base', kErrorBase),
                ],
              ),
              avatarColor: k.options(
                'Avatar Color',
                initial: kPrimaryBase,
                options: [
                  Option('Primary Light', kPrimaryLighten5),
                  Option('Success Light', kSuccessLighten5),
                  Option('Accent Light', kAccentLighten5),
                  Option('Warning Light', kWarningLighten5),
                  Option('Error Light', kErrorLighten5),
                  Option('Primary Base', kPrimaryBase),
                  Option('Success Base', kSuccessBase),
                  Option('Accent Base', kAccentBase),
                  Option('Warning Base', kWarningBase),
                  Option('Error Base', kErrorBase),
                ],
              ),
              username: k.text('Username', initial: 'Default'),
              profileImageUrl:
                  k.options('Profile Image', initial: '', options: [
                Option('Persona A', 'assets/img/personas/circle-user.png'),
                Option('Persona B', 'assets/img/personas/circle-user2.png'),
                Option('Persona C', 'assets/img/personas/circle-user3.png'),
                Option('No Image', ''),
              ]),
            ),
          ),

          ///FormControl: TextFields
          Story.simple(
              section: 'TextField',
              name: 'Default - Textfield',
              child: TextFieldDefault(
                suffixIcon: Icons.location_on_outlined,
                helperHint: 'www.example.com',
                readOnly: false,
                enabled: true,
                label: 'Label',
                maxlength: 20,
              )),

          Story.simple(
              section: 'TextField',
              name: 'Dense - Textfield',
              child: TextFieldDense(
                readOnly: false,
                enabled: true,
                label: 'Label',
              )),

          Story.simple(
              section: 'TextField',
              name: 'Clearable - Textfield',
              child: TextFieldClearable(
                enabled: true,
                readOnly: false,
                label: 'Label',
              )),
          Story.simple(
              section: 'TextField',
              name: 'Password - Textfield',
              child: TextFieldPassword(
                enabled: true,
                readOnly: false,
                label: 'Label',
              )),
          Story.simple(
              section: 'TextField',
              name: 'Suffix- Textfield',
              child: TextFieldSuffixText(
                enabled: true,
                readOnly: false,
                label: 'Label',
                suffixString: '@mail.com',
              )),

          /// END TEXTFIELD

          /// BEGIN SELECT
          Story.simple(
              section: 'Select',
              name: 'Default - Select',
              child: SelectDefault(
                options: ['Select One', 'Select two', 'Select three'],
                labelText: 'Select',
                enabled: true,
                readonly: false,
                validator: (String? str) {
                  if (str == null || str.isEmpty) {
                    return 'Select Something';
                  }
                  return '';
                },
                labelTextColor: kDarkNeutralLighten3,
                suffixIcon: Icon(Icons.keyboard_arrow_down),
                selected: 'Select One',
                onChanged: (String? val) {},
              )),

          Story.simple(
              section: 'Select',
              name: 'Dense - Select',
              child: DenseDefault(
                options: ['Select One', 'Select two', 'Select three'],
                labelText: 'Label',
                hintText: 'Select',
                enabled: true,
                readonly: false,
                validator: (String? str) {
                  if (str == null || str.isEmpty) {
                    return 'Select Something';
                  }
                  return '';
                },
                labelTextColor: kDarkNeutralLighten3,
                suffixIcon: Icon(Icons.keyboard_arrow_down),
                selected: null,
                onChanged: (String? val) {},
              )),

          Story.simple(
              section: 'Select',
              name: 'Icons - Select',
              child: IconsDefault(
                options: ['Select One', 'Select two', 'Select three'],
                labelText: 'Label',
                hintText: 'Select',
                enabled: true,
                readonly: false,
                validator: (String? str) {
                  if (str == null || str.isEmpty) {
                    return 'Select Something';
                  }
                  return '';
                },
                labelTextColor: kDarkNeutralLighten3,
                suffixIcon: Icon(Icons.keyboard_arrow_down),
                selected: null,
                onChanged: (String? val) {},
              )),

          Story.simple(
              section: 'Select',
              name: 'Hint - Select',
              child: HintDefault(
                options: ['Select One', 'Select two', 'Select three'],
                labelText: 'Label',
                hintText: 'Select your preferred location',
                enabled: true,
                readonly: false,
                validator: (String? str) {
                  if (str == null || str.isEmpty) {
                    return 'Select Something';
                  }
                  return '';
                },
                labelTextColor: kDarkNeutralLighten3,
                suffixIcon: Icon(Icons.keyboard_arrow_down),
                selected: null,
                onChanged: (String? val) {},
              )),

          //begin radios
          Story(
            section: 'Radios',
            name: 'Radio',
            padding: EdgeInsets.all(5), // optional padding customization
            builder: (_, k) => RadioButton(
                color: k.options(
                  'Radio Color',
                  initial: kPrimaryBase,
                  options: [
                    Option('Primary Base', kPrimaryBase),
                    Option('Success Base', kSuccessBase),
                    Option('Accent Base', kAccentBase),
                    Option('Warning Base', kWarningBase),
                    Option('Error Base', kErrorBase),
                  ],
                ),
                enabled: k.boolean(
                  'Enabled',
                  initial: true,
                ),
                radioValue: true),
          ),
          //end radio

          //begin radios
          Story(
            section: 'Checkbox',
            name: 'Default Checkbox',
            builder: (_, k) => CheckboxButton(
                color: k.options(
                  'Checkbox Color',
                  initial: kPrimaryBase,
                  options: [
                    Option('Primary Base', kPrimaryBase),
                    Option('Success Base', kSuccessBase),
                    Option('Accent Base', kAccentBase),
                    Option('Warning Base', kWarningBase),
                    Option('Error Base', kErrorBase),
                  ],
                ),
                enabled: k.boolean(
                  'Enabled',
                  initial: true,
                ),
                value: true),
          ),
          //end radio

          ///SLIDERS BEGIN HERE
          Story(
            section: 'Slider',
            name: 'Simple Slider',
            padding: EdgeInsets.all(5), // optional padding customization
            builder: (_, k) => SliderSimple(
              min: 0.0,
              max: 100.0,
              divisions: 1000,
              sliderColor: k.options(
                'Color',
                initial: kPrimaryBase,
                options: [
                  Option('Primary Base', kPrimaryBase),
                  Option('Success Base', kSuccessBase),
                  Option('Accent Base', kAccentBase),
                  Option('Warning Base', kWarningBase),
                  Option('Error Base', kErrorBase),
                ],
              ),
            ),
          ),
          Story(
            section: 'Slider',
            name: 'Paddle Slider',
            padding: EdgeInsets.all(5), // optional padding customization
            builder: (_, k) => SliderPaddleShape(
              min: 0.0,
              max: 100.0,
              divisions: 1000,
              sliderColor: k.options(
                'Color',
                initial: kPrimaryBase,
                options: [
                  Option('Primary Base', kPrimaryBase),
                  Option('Success Base', kSuccessBase),
                  Option('Accent Base', kAccentBase),
                  Option('Warning Base', kWarningBase),
                  Option('Error Base', kErrorBase),
                ],
              ),
            ),
          ),

          /// TEXT AREA STARTS
          Story.simple(
              section: 'TextArea',
              name: 'Default - TextArea',
              child: TextAreaDefault(
                suffixIcon: Icons.location_on_outlined,
                helperHint: 'www.example.com',
                readOnly: false,
                enabled: true,
                label: 'Label',
                maxlength: 500,
              )),
          Story.simple(
              section: 'TextArea',
              name: 'Clearable - TextArea',
              child: TextAreaClearable(
                readOnly: false,
                enabled: true,
                label: 'Label',
              )),

          Story(
              section: 'Button',
              name: 'Button',
              // padding: EdgeInsets.all(5), // optional padding customization
              builder: (_, k) => Button(
                    filled: k.boolean('Filled', initial: true),
                    border: k.boolean('Border', initial: true),
                    loading: k.boolean('Loading', initial: false),
                    disabled: k.boolean('Diabled', initial: false),
                    type: k
                        .options("Type", initial: ButtonType.PRIMARY, options: [
                      Option('Primary', ButtonType.PRIMARY),
                      Option('FAB', ButtonType.FAB),
                      Option('Icon Only', ButtonType.ICON),
                    ]),
                    color: k.options("Color Variation",
                        initial: kPrimaryBase,
                        options: [
                          Option('Primary', kPrimaryBase),
                          Option('Success', kSuccessBase),
                          Option('Accent', kAccentBase),
                          Option('Warning', kWarningBase),
                          Option('Error', kErrorBase),
                        ]),
                    borderColor: k.options("BorderColor Variation",
                        initial: kPrimaryBase,
                        options: [
                          Option('Primary', kPrimaryBase),
                          Option('Success', kSuccessBase),
                          Option('Accent', kAccentBase),
                          Option('Warning', kWarningBase),
                          Option('Error', kErrorBase),
                        ]),
                    indicatorColor: k.options("IndicatorColor Variation",
                        initial: kLightNeutralLighten0,
                        options: [
                          Option('Primary Light', kPrimaryDarken1),
                          Option('Light', kLightNeutralLighten0),
                          Option('Success Light', kSuccessDarken1),
                          Option('Accent Light', kAccentDarken1),
                          Option('Warning Light', kWarningDarken1),
                          Option('Error Light', kErrorDarken1),
                        ]),
                    indicatorValueColor: k.options(
                        "IndicatorValueColor Variation",
                        initial: kPrimaryBase,
                        options: [
                          Option('Primary', kPrimaryBase),
                          Option('Success', kSuccessBase),
                          Option('Accent', kAccentBase),
                          Option('Warning', kWarningBase),
                          Option('Error', kErrorBase),
                        ]),
                    size:
                        k.options("Size", initial: ButtonSize.NORMAL, options: [
                      Option('Small', ButtonSize.SMALL),
                      Option('Normal', ButtonSize.NORMAL),
                      Option('Large', ButtonSize.LARGE),
                      Option('XLarge', ButtonSize.XLARGE),
                    ]),
                    text: k.text('Username', initial: 'Bento'),
                    icon: k.options('Icon',
                        initial: 'assets/img/button-icon.png',
                        options: [
                          Option('Circular', "assets/img/button-icon.png"),
                          Option('Non Circluar',
                              "assets/img/button-icon-noCircle.png"),
                          Option('No Icon', ''),
                        ]),
                  )),

          Story.simple(
            section: 'Button',
            name: 'Full Screen Normal',
            padding: EdgeInsets.all(5), // optional padding customization
            child: Button(
                fullScreen: true,
                loading: false,
                size: ButtonSize.LARGE,
                icon: '',
                filled: true,
                type: ButtonType.PRIMARY),
          ),
          Story.simple(
            section: 'Button',
            name: 'Full Screen Normal Outline',
            padding: EdgeInsets.all(5), // optional padding customization
            child: Button(
                fullScreen: true,
                loading: false,
                size: ButtonSize.NORMAL,
                icon: '',
                filled: false,
                type: ButtonType.PRIMARY),
          ),

          Story.simple(
            section: 'Button',
            name: 'Full Screen Large ',
            padding: EdgeInsets.all(5), // optional padding customization
            child: Button(
                fullScreen: true,
                loading: false,
                size: ButtonSize.LARGE,
                icon: '',
                filled: true,
                type: ButtonType.PRIMARY),
          ),

          Story.simple(
            section: 'Button',
            name: 'Full Screen Large Outline',
            padding: EdgeInsets.all(5), // optional padding customization
            child: Button(
                fullScreen: true,
                loading: false,
                size: ButtonSize.LARGE,
                icon: '',
                text: "Bento",
                filled: false,
                type: ButtonType.PRIMARY),
          ),
          Story(
            section: 'Paper',
            name: 'Paper',
            padding: EdgeInsets.all(5), // optional padding customization
            builder: (_, k) => Paper(
              hasElevation: k.boolean('Elevation', initial: true),
              spreadRadius: k.options('Spread Radius', initial: 24, options: [
                Option('-32', 32),
                Option('-24', 24),
              ]),
              color: k.options(
                'Color',
                initial: kLightNeutralBase,
                options: [
                  Option('Primary Base', kPrimaryBase),
                  Option('Success Base', kSuccessBase),
                  Option('Accent Base', kAccentBase),
                  Option('Warning Base', kWarningBase),
                  Option('Error Base', kErrorBase),
                  Option('Lighten5', kPrimaryLighten5),
                  Option('Lighten', kLightNeutralBase),
                ],
              ),
              shadowColor: k.options(
                'Shadow Color',
                initial: kLightBoxShadow,
                options: [
                  Option('Primary Base', kPrimaryBaseBoxShadow),
                  Option('Success Base', kSuccessBaseBoxShadow),
                  Option('Accent Base', kAccentBaseBoxShadow),
                  Option('Warning Base', kWarningBaseBoxShadow),
                  Option('Error Base', kErrorBaseBoxShadow),
                  Option('Light Base', kLightBoxShadow),
                  Option('Dark Base', kDarkBoxShadow),
                ],
              ),
              borderRadius: k.options('Border Radius', initial: 16, options: [
                Option('Very Large', 32),
                Option('Large', 24),
                Option('Small', 8),
                Option('Medium', 16),
                Option('Extreme', 40),
                Option('Rounded', 50),
              ]),
              blurRadius: k.options('Blur Radius', initial: 100, options: [
                Option('100', 100),
                Option('80', 80),
                Option('110', 110),
              ]),
            ),
          ),

          //buttons end
          // tooltip starts

          Story(
              background: kLightNeutralLighten0,
              section: 'ToolTip',
              name: 'Default ToolTip',
              padding: EdgeInsets.all(5),
              builder: (_, k) => DefaultToolTip(
                    borderRadius: 4,
                    arrowWidth: 13,
                    arrowHeight: 6,
                    padding: EdgeInsets.symmetric(horizontal: 10, vertical: 7),
                    direction: k.options('Direction',
                        initial: ArrowDirection.right,
                        options: [
                          Option('Left', ArrowDirection.left),
                          Option('Right', ArrowDirection.right),
                          Option('Bottom', ArrowDirection.bottom),
                          Option('Top', ArrowDirection.top),
                        ]),
                    text: k.text('Text', initial: 'I am a tooltip'),
                  )),
          //tooltip ends
          //date picker starts

          Story.simple(
            section: 'Picker',
            name: 'Date Picker',

            padding: EdgeInsets.all(5), // optional padding customization
            child: DatePicker(
              selectedValue: DateTime.now(),
              dateController: TextEditingController(),
              onChanged: (_) {},
            ),
          ),
          Story.simple(
            section: 'Picker',
            name: ' New Date Picker',

            padding: EdgeInsets.all(5), // optional padding customization
            child: NewDatePicker(
              selectedValue: DateTime.now(),
              onChanged: (_) {},
            ),
          ),
          Story.simple(
            section: 'Picker',
            name: 'TimePicker',
            padding: EdgeInsets.all(5), // optional padding customization
            child: TimePicker(
              selectedValue: DateTime.now(),
              timeController: TextEditingController(),
              onChanged: (_) {},
            ),
          ),

          //date picker end

          /// banner begins
          Story.simple(
            section: 'Banner',
            name: 'Banner with LeadingIcon',
            padding: EdgeInsets.all(5), // optional padding customization
            child: BannerDefault(
              withTrailingIcon: true,
              message: 'Your email address is now connected to a Company.'
                  '\nContact your Company to get you started on Bento.',
            ),
          ),

          Story.simple(
            section: 'Banner',
            name: 'Banner withOutlineButton',
            padding: EdgeInsets.all(5), // optional padding customization
            child: BannerOutlineButton(
              message: 'Your email address is now connected to a Company.'
                  '\nContact your Company to get you started on Bento.',
            ),
          ),

          Story.simple(
            section: 'Banner',
            name: 'Banner withFilledButton',
            padding: EdgeInsets.all(5), // optional padding customization
            child: BannerFilledButton(
              message: 'Your email address is now connected to a Company.'
                  '\nContact your Company to get you started on Bento.',
            ),
          ),

          ///banners end

          //switches start

          Story(
              section: 'Switches',
              name: 'Switch',
              builder: (_, k) => Switches(
                    color: k.options(
                      'Color',
                      initial: kPrimaryBase,
                      options: [
                        Option('Primary Base', kPrimaryBase),
                        Option('Success Base', kSuccessBase),
                        Option('Accent Base', kAccentBase),
                        Option('Warning Base', kWarningBase),
                        Option('Error Base', kErrorBase),
                      ],
                    ),
                    disabled: k.boolean('Disabled', initial: false),
                  )),
          //switches end

          //snackbar begins
          Story(
              section: 'Snackbar',
              name: 'Snackbar',
              builder: (_, k) => GestureDetector(
                    onTap: () {
                      Snackbar(
                        message: "",
                        onStatusChanged: (status) {},
                        title: k.text('Title', initial: 'I am a snackbar'),
                        snackbarPosition: k.options("Position",
                            initial: SnackbarPosition.BOTTOM,
                            options: [
                              Option('TOP', SnackbarPosition.TOP),
                              Option('BOTTOM', SnackbarPosition.BOTTOM),
                            ]),
                        padding:
                            EdgeInsets.symmetric(vertical: 25, horizontal: 18),
                        margin:
                            EdgeInsets.symmetric(horizontal: 10, vertical: 20),
                        snackbarStyle: SnackbarStyle.FLOATING,
                        trailingButton: GestureDetector(
                          onTap: () => Navigator.pop(context),
                          child: Text(
                            "Close",
                            style: TextStyle(
                                fontWeight: FontWeight.w700,
                                fontFamily: "Proxima Nova",
                                color: kPrimaryDarken4),
                          ),
                        ),
                        borderRadius: 8,
                        textColor: k.options('TextColor',
                            initial: kDarkNeutralBase,
                            options: [
                              Option('Primary Darken', kPrimaryDarken4),
                              Option('Success Darken', kSuccessDarken4),
                              Option('Warning Darken', kWarningDarken4),
                              Option('Accent Darken', kAccentDarken4),
                              Option('Error Darken', kErrorDarken4),
                              Option('Dark Base', kDarkNeutralBase),
                              Option('Light Neutral', kLightNeutralLighten0),
                            ]),
                        backgroundColor: k.options(
                          'Color',
                          initial: kPrimaryLighten5,
                          options: [
                            Option('Primary Light', kPrimaryLighten5),
                            Option('Success Light', kSuccessLighten5),
                            Option('Accent Light', kAccentLighten5),
                            Option('Warning Light', kWarningLighten5),
                            Option('Error Light', kErrorLighten5),
                            Option('Primary Base', kPrimaryBase),
                            Option('Success Base', kSuccessBase),
                            Option('Accent Base', kAccentBase),
                            Option('Warning Base', kWarningBase),
                            Option('Error Base', kErrorBase),
                          ],
                        ),
                        fontSize: 12,
                        leftBarIndicatorColor: Colors.blue.shade300,
                        duration: Duration(seconds: 5),
                      )..show(context);
                    },
                    child: Container(
                      padding: EdgeInsets.all(15),
                      decoration: BoxDecoration(
                          color: kPrimaryBase,
                          borderRadius: BorderRadius.circular(10)),
                      child: Text(
                        "Show Snackbar",
                        style: TextStyle(color: kPrimaryLighten0),
                      ),
                    ),
                  )),
          Story(
              section: 'Snackbar',
              name: 'Snackbar With Icon',
              builder: (_, k) => GestureDetector(
                    onTap: () {
                      SnackbarHelper.withIcon(
                          title: "I am a snackbar",
                          message: "",
                          snackbarPosition: SnackbarPosition.BOTTOM,
                          snackbarStyle: SnackbarStyle.FLOATING,
                          textColor: k.options('TextColor',
                              initial: kPrimaryLighten0,
                              options: [
                                Option('Primary Darken', kPrimaryDarken4),
                                Option('Success Darken', kSuccessDarken4),
                                Option('Warning Darken', kWarningDarken4),
                                Option('Accent Darken', kAccentDarken4),
                                Option('Error Darken', kErrorDarken4),
                                Option('Dark Base', kDarkNeutralBase),
                                Option('Light Neutral', kLightNeutralLighten0),
                              ]),
                          bgColor: k.options(
                            'Color',
                            initial: kAccentBase,
                            options: [
                              Option('Primary Light', kPrimaryLighten5),
                              Option('Success Light', kSuccessLighten5),
                              Option('Accent Light', kAccentLighten5),
                              Option('Warning Light', kWarningLighten5),
                              Option('Error Light', kErrorLighten5),
                              Option('Primary Base', kPrimaryBase),
                              Option('Success Base', kSuccessBase),
                              Option('Accent Base', kAccentBase),
                              Option('Warning Base', kWarningBase),
                              Option('Error Base', kErrorBase),
                            ],
                          ),
                          icon: Icon(
                            Icons.info,
                            size: 28.0,
                            color: kPrimaryLighten0,
                          ),
                          trailingButton: GestureDetector(
                            onTap: () => print("works"),
                            child: Text(
                              "Close",
                              style: TextStyle(
                                  fontWeight: FontWeight.w700,
                                  fontFamily: "Proxima Nova",
                                  color: kPrimaryLighten0),
                            ),
                          ),
                          context: context)
                        ..show(context);
                    },
                    child: Container(
                      padding: EdgeInsets.all(15),
                      decoration: BoxDecoration(
                          color: kPrimaryBase,
                          borderRadius: BorderRadius.circular(10)),
                      child: Text(
                        "Show Snackbar With Icon",
                        style: TextStyle(color: kPrimaryLighten0),
                      ),
                    ),
                  )),

          ///end of banner
          ///begin Charts
          Story(
            section: 'Charts',
            name: 'Linear',
            padding: EdgeInsets.all(5), // optional padding customization
            builder: (_, k) => ProgressLinear(
              percentage: k.text('Percentage', initial: '50.0'),
              backgroundColor: k.options(
                'background Color',
                initial: kPrimaryLighten5,
                options: [
                  Option('Primary', kPrimaryLighten5),
                  Option('Success', kSuccessLighten5),
                  Option('Accent', kAccentLighten5),
                  Option('Warning', kWarningLighten5),
                  Option('Error', kErrorLighten5),
                ],
              ),
              progressColor: k.options(
                'progress Color',
                initial: kPrimaryBase,
                options: [
                  Option('Primary', kPrimaryBase),
                  Option('Success', kSuccessBase),
                  Option('Accent', kAccentBase),
                  Option('Warning', kWarningBase),
                  Option('Error', kErrorBase),
                ],
              ),
            ),
          ),

          Story(
            section: 'Charts',
            name: 'Circular',
            padding: EdgeInsets.all(5), // optional padding customization
            builder: (_, k) => ProgressCircular(
              percentage: k.text('Percentage', initial: '50.0'),
              size: k.options(
                'Radius',
                initial: 32.0,
                options: [
                  Option('small', 24.0),
                  Option('normal', 32.0),
                  Option('large', 40.0),
                  Option('Xlarge', 48.0),
                ],
              ),
              backgroundColor: k.options(
                'background Color',
                initial: kPrimaryLighten5,
                options: [
                  Option('Primary', kPrimaryLighten5),
                  Option('Success', kSuccessLighten5),
                  Option('Accent', kAccentLighten5),
                  Option('Warning', kWarningLighten5),
                  Option('Error', kErrorLighten5),
                ],
              ),
              lineWidth: k.options(
                'width',
                initial: 4.0,
                options: [
                  Option('4.0', 4.0),
                  Option('2.0', 2.0),
                ],
              ),
              progressColor: k.options(
                'progress Color',
                initial: kPrimaryBase,
                options: [
                  Option('Primary', kPrimaryBase),
                  Option('Success', kSuccessBase),
                  Option('Accent', kAccentBase),
                  Option('Warning', kWarningBase),
                  Option('Error', kErrorBase),
                ],
              ),
            ),
          ),

          ///Dialog starts
          Story.simple(
            section: 'Dialog',
            name: 'Dialog with icon',
            padding: EdgeInsets.all(5), // optional padding customization
            child: DialogWithIcon(
                // onCancel: () {},
                // onCloseModal: () {},
                // onTapAction: () {},
                // withCancelButton: true,
                // message: 'Your request to enable Bento wallet has been received.'
                //     '\nA confirmation email has been sent to you.',
                ),
          ),

          Story.simple(
            section: 'Dialog',
            name: 'Scrollable',
            padding: EdgeInsets.all(5), // optional padding customization
            child: DialogScrollable(),
          ),

          Story.simple(
              section: 'Dialog',
              name: 'Form',
              padding: EdgeInsets.all(5), // optional padding customization
              child: DialogForm(
                children: [
                  TextFieldDefault(
                      label: 'label', readOnly: false, enabled: true),
                  TextFieldDefault(
                      label: 'label', readOnly: false, enabled: true),
                  TextFieldDefault(
                      label: 'label', readOnly: false, enabled: true),
                  TextFieldDefault(
                      label: 'label', readOnly: false, enabled: true),
                ],
                onTapAction: () {
                  print("object");
                },
                noOfTextFields: 3,
                label: 'Sample',
              )),

          //switches end

          Story(
            section: 'Charts',
            name: 'Rotate',
            padding: EdgeInsets.all(5), // optional padding customization
            builder: (_, k) => ProgressRotate(
              percentage: k.text('Percentage', initial: '50'),
              radius: k.options(
                'Radius',
                initial: 48.0,
                options: [
                  Option('normal', 48.0),
                  Option('large', 56.0),
                  Option('Xlarge', 64.0),
                  Option('XXlarge', 72.0),
                ],
              ),
              percentFontSize: k.options(
                'percent Size',
                initial: 12.0,
                options: [
                  Option('normal', 12.0),
                  Option('large', 14.0),
                  Option('Xlarge/ XXlarge', 16.0),
                ],
              ),
              backgroundColor: k.options(
                'background Color',
                initial: kPrimaryLighten5,
                options: [
                  Option('Primary', kPrimaryLighten5),
                  Option('Success', kSuccessLighten5),
                  Option('Accent', kAccentLighten5),
                  Option('Warning', kWarningLighten5),
                  Option('Error', kErrorLighten5),
                ],
              ),
              progressColor: k.options(
                'progress Color',
                initial: kPrimaryBase,
                options: [
                  Option('Primary', kPrimaryBase),
                  Option('Success', kSuccessBase),
                  Option('Accent', kAccentBase),
                  Option('Warning', kWarningBase),
                  Option('Error', kErrorBase),
                ],
              ),
            ),
          ),

          ///MobileTabs
          Story.simple(
            section: 'Tabs',
            name: 'Tabs Default',
            padding: EdgeInsets.all(5), // optional padding customization
            child: MobileTabs(),
          ),
          Story.simple(
            section: 'Tabs',
            name: 'Tabs Dynamic',
            padding: EdgeInsets.all(5), // optional padding customization
            child: MobileTabsDynamic(
              tab: ['1', '2', '3', '4', '5', '6'],
              tabViews: [
                Container(
                  child: Center(child: Text('I am the first tabView widget')),
                ),
                Container(
                  child: Center(child: Text('I am the second tabView widget')),
                ),
                Container(
                  child: Center(child: Text('I am the third tabView widget')),
                ),
                Container(
                  child: Center(child: Text('I am the fourth tabView widget')),
                ),
                Container(
                  child: Center(child: Text('I am the fifth tabView widget')),
                ),
                Container(
                  child: Center(child: Text('I am the sixth tabView widget')),
                ),
              ],
            ),
          ),
        ],
      ));
}
