import 'package:flutter/material.dart';
import 'package:rothko_mobile/knobs/select_knobs.dart';
import 'package:rothko_mobile/widgets/story.dart';
import 'package:rothko_mobile/widgets/storybook.dart';

class StoryExample extends StatelessWidget {
  @override
  Widget build(BuildContext context) => Storybook(
        children: [
          Story(
            section: 'Buttons',
            name: 'Flat button',
            padding: EdgeInsets.all(5), // optional padding customization
            // background: Colors.r, // optional background color customization
            builder: (_, k) => MaterialButton(
              onPressed: k.boolean('Enabled', initial: true) ? () {} : null,
              child: Text(k.text('Text', initial: 'Flat Button')),
              color: k.options('Color', initial: Colors.purple, options: [
                Option('Purple', Colors.purple),
                Option('Green', Colors.green),
              ]),
            ),
          ),
          Story(
            section: 'Buttons',
            name: 'Raised button',
            builder: (_, k) => RaisedButton(
              onPressed: k.boolean('Enabled', initial: true) ? () {} : null,
              color: k.options(
                'Color',
                initial: Colors.deepOrange,
                options: const [
                  Option('Red', Colors.deepOrange),
                  Option('Green', Colors.teal),
                ],
              ),
              textColor: k
                  .options('TextColor', initial: Colors.purple, options: const [
                Option('Purple', Colors.purple),
                Option('Green', Colors.green),
              ]),
              child: Text(k.text('Text', initial: 'Raised button')),
            ),
          ),
          Story.simple(
            name: 'Input field',
            child: const TextField(
              decoration: InputDecoration(
                border: OutlineInputBorder(),
                labelText: 'Input field',
              ),
            ),
          ),
        ],
      );
}
