import 'package:flutter/material.dart';
import 'package:rothko_mobile/cache.dart';

class ThemeSwitcher extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return IconButton(
      icon: RothkoCache.getTheme!(context).icon,
      onPressed: () {
        RothkoCache.toggle!();
      },
    );
  }
}

extension on ThemeMode {
  // ignore: missing_return
  Icon get icon {
    switch (this) {
      case ThemeMode.system:
        return const Icon(Icons.brightness_auto);
      case ThemeMode.light:
        return const Icon(Icons.brightness_high);
      case ThemeMode.dark:
        return const Icon(Icons.brightness_3);
    }
  }
}
